<?php



function kstats_display_options() {
	global $kstats;

	$kstats->refresh_options();

?>
	<div class="postbox-container" style="width: 70%;">
	<div class="metabox-holder">	
	<div class="meta-box-sortables">
		<form action="options.php" id="kstatsadmin" method="post">
		<?php
        	settings_fields('kstats_admin_options');

			kstats_postbox_main_display_options();
			kstats_postbox_main_access_control();
			kstats_postbox_main_ignore_lists()
		?>
		</form>
	</div></div>
	</div> <!-- .postbox-container -->

	<div class="postbox-container" style="width: 24%;">
	<div class="metabox-holder">	
	<div class="meta-box-sortables">
	<?php
		kstats_postbox_support();
		_kstats_load_library( KSTATS_UTILITIES_BASE );
	?>
	</div></div>
	</div> <!-- .postbox-container -->

<?php

}




function kstats_postbox_main_display_options() {
	global $kstats;

	$output  = "<script type=\"text/javascript\">\n";

	if ( $kstats->config['dashboard']['display_widget'] == 0 ) {

		$output .= "\tjQuery(document).ready(function($) {\n";
		$output .= "\t\t$('.hide').hide()\n";
		$output .= "\t})\n";
	}

	$output .= "\tfunction toggleDW() {\n";
	$output .= "\t\tjQuery('.hide').slideToggle();\n";
	$output .= "\t}\n";
	$output .= "\tfunction hideDW() {\n";
	$output .= "\t\tjQuery('.hide').hide();\n";
	$output .= "\t}\n";
	$output .= "</script>\n";

	$output .= '<div class="intro">';
	$output .= '<p>' . __( 'The following options control how kStats will function and display your statistics information.', 'kstats' ) . '</p>';
	$output .= '</div>';

	$options = array();

	$options[] = array( 'id'    => 'config_dashboard_display_widget',
					    'name'  => __( 'Dashboard Widget:', 'kstats' ),
						'desc'  => __( 'Display a widget on your dashboard with an overview chart and bar graph.', 'kstats' ),
						'input' => '<input name="kstats_options[config_dashboard_display_widget]" type="radio" onClick="toggleDW()" value="1" ' . checked( '1', $kstats->config['dashboard']['display_widget'], FALSE ) . ' /><span>' . __( 'Yes', 'kstats' ) . '</span>' .
								   '<input name="kstats_options[config_dashboard_display_widget]" type="radio" onClick="toggleDW()" value="0" ' . checked( '0', $kstats->config['dashboard']['display_widget'], FALSE ) . ' /><span>' . __( 'No', 'kstats' ) . '</span>'
					   );

	$options[] = array( 'id'    => 'config_dashboard_days_to_show',
					    'class' => 'hide',
					    'name'  => __( 'Dashboard Days to Display:', 'kstats' ),
						'desc'  => __( 'How many days of data to display on the dashboard widget graph.', 'kstats' ),
						'input' => '<input name="kstats_options[config_dashboard_days_to_show]" type="text" value="' . $kstats->config['dashboard']['days_to_show'] . '" />'
					   );

	$options[] = array( 'id'    => 'config_overview_days_to_show',
					    'name'  => __( 'Overview Days to Display:', 'kstats' ),
						'desc'  => __( 'How many days of data to display on the primary bar graph.', 'kstats' ),
						'input' => '<input name="kstats_options[config_overview_days_to_show]" type="text" value="' . $kstats->config['overview']['days_to_show'] . '" />'
					   );

	$options[] = array( 'id'    => 'config_overview_recent_hits_to_show',
					    'name'  => __( 'Recent Hits to Display:', 'kstats' ),
						'desc'  => __( 'How many recent hits you would displayed on the statistics overview page.', 'kstats' ),
						'input' => '<input name="kstats_options[config_overview_recent_hits_to_show]" type="text" value="' . $kstats->config['overview']['recent_hits_to_show'] . '" />'
					   );

	$output .= kstats_options_build_form( $options );

	kstats_build_postbox( 'display_options', __( 'Display Options', 'kstats' ), $output );

}





function kstats_postbox_main_access_control() {
	global $kstats, $current_user;

	$options = array();

	$options[] = array( 'id'    => 'config_access_minimum_to_view',
					    'name'  => __( 'View Statistics:', 'kstats' ),
						'desc'  => __( 'The minimum access level required to view statistics for your blog.', 'kstats' ),
						'input' => '<select name="kstats_options[config_access_minimum_to_view]">' . kstats_options_dropdown_roles( $kstats->config['access']['minimum_to_view'] ) . '</select>'
					   );

	$options[] = array( 'id'    => 'config_access_minimum_to_edit',
					    'name'  => __( 'Edit Options:', 'kstats' ),
						'desc'  => __( 'The minimum access level required to modify kStats options.', 'kstats' ),
						'input' => '<select name="kstats_options[config_access_minimum_to_edit]">' . kstats_options_dropdown_roles( $kstats->config['access']['minimum_to_edit'] ) . '</select>'
					   );

	$output = '<div class="intro">';
	$output .= '<p>' . __( 'The following options can be used to control how kStats will permit access to various areas of operation.', 'kstats' ) . '</p>';

	if ( current_user_can( 'create_users' ) )
		$output .= '<p>' . __( 'As the blog owner, you are automatically granted full access; from here you can set the permissions level necessary for other users of the blog to view your statistics or edit the configuration.', 'kstats' ) . '</p>';

	$output .= '</div>';

	$output .= kstats_options_build_form( $options );

	kstats_build_postbox( 'access_control', __( 'Access Control', 'kstats' ), $output );
}


function kstats_postbox_main_ignore_lists() {
	global $kstats;

	$options = array();

	$options[] = array( 'id'    => 'config_ignore_ignore_list',
					    'name'  => __( 'Ignore List:', 'kstats' ),
						'desc'  => __( 'A list of IP addresses you would like kStats to ignore when recording statistics. You can use an incomplete address to block entire ranges, each IP on its own line.', 'kstats' ),
						'input' => '<textarea name="kstats_options[config_ignore_ignore_list]" type="text" rows="4" cols="20">' . ( is_array( $kstats->config['ignore']['ignore_list'] ) ? implode( "\r\n", $kstats->config['ignore']['ignore_list'] ) : '' ) . '</textarea>'
					   );

	$output = '<div class="intro">';
	$output .= '<p>' . __( 'The following options can be used to control how kStats will permit access to various areas of operation.', 'kstats' ) . '</p>';
	$output .= '</div>';

	$output .= kstats_options_build_form( $options );

	kstats_build_postbox( 'ignore_lists', __( 'Ignore Lists', 'kstats' ), $output );
}


function kstats_options_build_form( $options ) {

	$output = '<fieldset>';

	foreach ( $options as $option ) {

		$output .= '<dl' . ( isset( $option['class'] ) ? ' class="' . $option['class'] . '"' : '' ) . '>';
		$output .= '<dt><label for="kstats_options[' . $option['id'] . '">' . $option['name'] . '</label>';

		if ( isset( $option['desc'] ) )
			$output .= '<p>' . $option['desc'] . '</p>';

		$output .= '</dt>';
		$output .= '<dd>' . $option['input'] . '</dd>';
		$output .= '</dl>';

	}

	$output .= '<div style="clear: both;"></div>';
	$output .= '<p class="kstats_submit"><input type="submit" class="button-secondary" value="' . __( 'Save Changes', 'kstats' ) . '" /></p>';
	$output .= '</fieldset>';

	return $output;

}


function kstats_postbox_support() {

	$output  = '<p>' . __( 'If you require support, or would like to contribute to the further development of this plugin, please choose one of the following;', 'kstats' ) . '</p>';
	$output .= '<ul class="links">';
	$output .= '<li><a href="http://mark.watero.us/">' . __( 'Author Homepage', 'kstats' ) . '</a></li>';
	$output .= '<li><a href="http://mark.watero.us/">' . __( 'Plugin Homepage', 'kstats' ) . '</a></li>';
	$output .= '<li><a href="http://wordpress.org/extend/plugins/kstats-reloaded/">' . __( 'Rate This Plugin', 'kstats' ) . '</a></li>';
	$output .= '<li><a href="http://mark.watero.us/kstats-reloaded/bug-reports/">' . __( 'Bug Reports', 'kstats' ) . '</a></li>';
	$output .= '<li><a href="http://mark.watero.us/2009/10/statistics-analysis-wordpress-feature-requests/">' . __( 'Feature Requests', 'kstats' ) . '</a></li>';
	$output .= '<li><a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=9847234">' . __( 'Donate To The Cause', 'kstats' ) . '</a></li>';
	$output .= '</ul>';

	kstats_build_postbox( 'support', 'kStats Reloaded', $output );
}


function kstats_options_dropdown_roles( $selected = FALSE ) {
	global $wp_roles;

//	die( $selected );
	$p = '';
	$r = '';

	$editable_roles = get_editable_roles();

	foreach( $editable_roles as $role => $details ) {
		$name = translate_user_role($details['name'] );
		if ( strtolower( $selected ) == $role ) // Make default first in list
			$p = "\n\t<option selected='selected' value='" . esc_attr($role) . "'>$name</option>";
		else
			$r .= "\n\t<option value='" . esc_attr($role) . "'>$name</option>";
	}
	return $p . $r;
}
